package org.expeditee.gui;

import java.awt.event.InputEvent;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import junit.framework.TestCase;

import org.expeditee.items.Item;

public class DisplayIOTest extends TestCase {
	static Browser b;

	protected void setUp() throws Exception {
		b = Browser.initialize();
		super.setUp();
	}

	public final void testToggleTwinFrames() {
		DisplayIO.setCurrentFrame(FrameIO.LoadFrame("ExpediteeTest1"), true);
		DisplayIO.ToggleTwinFrames();
		assertTrue(DisplayIO.isTwinFramesOn());
		DisplayIO.ToggleTwinFrames();
		assertFalse(DisplayIO.isTwinFramesOn());
	}

	public final void testMouse() throws Exception{
		Frame testFrame = FrameIO.LoadFrame("ExpediteeTest1");
		testFrame.clear(false);
		DisplayIO.setCurrentFrame(testFrame, true);
		//Draw a line
		DisplayIO.setCursorPosition(100, 100);
		Thread.sleep(1000);
		DisplayIO.clickMouse(InputEvent.BUTTON2_MASK);
		Thread.sleep(100);
		DisplayIO.setCursorPosition(200, 200);
		Thread.sleep(100);
		DisplayIO.clickMouse(InputEvent.BUTTON2_MASK);
		Thread.sleep(100);
		//Draw a rectangle
		DisplayIO.setCursorPosition(250, 250);
		Thread.sleep(100);
		DisplayIO.clickMouse(InputEvent.BUTTON3_MASK);
		Thread.sleep(100);
		DisplayIO.setCursorPosition(500, 500);
		Thread.sleep(100);
		DisplayIO.clickMouse(InputEvent.BUTTON3_MASK);
		Thread.sleep(1000);
		//Check that the line is there
		Collection<Item> items = testFrame.getVisibleItems();
		assertTrue(items.size() == 12);
		Map<String, Integer> itemCounts = getItemCount(items);
		
	}

	private Map<String, Integer> getItemCount(Collection<Item> items) {
		Map<String, Integer> itemCounts = new HashMap<String,Integer>();
		for(Item i : items){
			String className = i.getClass().toString();
			if(itemCounts.containsKey(className)){
				itemCounts.put(className, itemCounts.get(className)+1);
			}else{
				itemCounts.put(className, 1);
			}
			
		}
		return itemCounts;
	}
	
	// public final void testReleaseMouse() {
	// fail("Not yet implemented");
	// }
	//
	// public final void testClickMouse() {
	// fail("Not yet implemented");
	// }

}
